#pragma title    ("File name:    " __FILE__)
#pragma subtitle ("Last updated: " __TIMESTAMP__)

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>

#define FALSE 0
#define TRUE  1
#define WIDTH 79

FILE * fms, * cat, * dir;

static char cats   [256] = "";
static char fms_dir [64] = "";
static char dir_tmp [64] = "";
static char dir_new [64] = "";
static char cat_fil [64] = "";
static char buf    [256] = "";
static char name    [32] = "";
static char desc    [64] = "";
static char head    [40] = ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>";
static char tail    [40] = "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<";

int  cdecl main     (const int, char * *);
void cdecl instruct (void);
int  cdecl getcat   (void);
int  cdecl readfms  (void);
void cdecl setdir   (char * *);
void cdecl stripz   (char *);
#pragma page ()
int main(const int argc, char * argv []) {
    int i;

    printf ("MakeDir version 1.2 by W. F. Muldrow.\n");
    if (argc < 3) {
        instruct ();
        return (1);
        }
    setdir (argv);
    stripz  (dir_tmp);
    remove  (dir_new);
    fms = fopen (fms_dir, "rt");
    cat = fopen (cat_fil, "rt");
    dir = fopen (dir_tmp, "at");
    if (fms == NULL || cat == NULL || dir == NULL) {
        printf ("File open error.\n");
        instruct ();
        return (1);
        }
    fclose (fms);
    while (! feof (cat)) {
        if (getcat ())
            break;
        i = strlen (head) - (WIDTH - 8 - strlen (name) - strlen (desc)) / 2;
        fprintf (dir, "\n\n%s  %s -- %s  %s\n\n",
                 &head[i], name, desc, &tail[i]);
        printf ("               Directory %s -- %s\r", name, desc);
        if ((i = readfms ()) < 0) {
            printf ("\n");
            return (1);
            }
        printf ("%5d files in\n", i);
        fprintf (dir, "\n%5d files in directory %s\n", i, name);
        }
    strcpy (buf, "pkzip -a ");
    strcat (buf, dir_new);
    strcat (buf, " ");
    strcat (buf, dir_tmp);
    system (buf);
    remove (dir_tmp);
    return (0);
    }
#pragma page ()
void setdir (char * argv []) {
    char *c;

    strcpy (cat_fil, argv [1]);
    strupr (cat_fil);
    if (strchr (cat_fil, '.') == NULL)
        strcat (cat_fil, ".CAT");
    strcpy (fms_dir, argv [2]);
    strupr (fms_dir);
    if (strchr (fms_dir, '.') == NULL)
        strcat (fms_dir, ".DIR");
    strcpy (dir_new, argv [3]);
    strupr (dir_new);
    c = strchr (dir_new, '.');
    if (c != NULL)
        *c = '\0';
    strcpy (dir_tmp, dir_new);
    strcat (dir_new, ".ZIP");
    strcat (dir_tmp, ".DIR");
    }
#pragma page ()
int getcat (void) {
    char *c, *d;

    if (fgets (buf, sizeof (buf), cat) == NULL)
        return (TRUE);
    c = buf;
    d = name;
    if (*c == '\"') {
        c++;
        while (*c != '\"')  *(d++) = *(c++);
        *d = '\0';
        *c++;
        }
    else {
        while (*c != ',' && !isspace (*c))  *(d++) = *(c++);
        *d = '\0';
        }
    while (isspace (*c) || *c == ',')  c++;
    d = cats;
    if (*c == '\"') {
        c++;
        while (*c != '\"')  *(d++) = *(c++);
        *c++;
        }
    else {
        while (*c != ',' && !isspace (*c))  *(d++) = *(c++);
        }
    *d = '\0';
    while (isspace (*c) || *c == ',')  c++;
    d = desc;
    if (*c == '\"') {
        c++;
        while (*c != '\"')  *(d++) = *(c++);
        *d = '\0';
        }
    else {
        while (*c != ',' && !isspace (*c) && *c != '\n')
            *(d++) = *(c++);
        *d = '\0';
        }
    return (FALSE);
    }
#pragma page ()
int readfms (void) {
    char *c;
    int   i;
    int   last;

    i = 0;
    last = 0;
    fms = fopen (fms_dir, "rt");
    if (fms == NULL)  return (-1);
    while (! feof (fms)) {
        if (fgets (buf, sizeof (buf), fms) == NULL)
            if (feof (fms))  break;
            else             return (-1);
        if (buf [0] == '=')  continue;
        c = strchr (buf, '\n');
        if (c == NULL)
            c = buf + strlen (buf);
        else
            *c = '\0';
        c = c - 3;
        if ((strstr (cats, c) != NULL) || (last > 0 && *buf == ' ')) {
            last = 1;
            *(c++) = '\n';
            *c = '\0';
            if (fputs (buf, dir) == EOF)  return (-1);
            i++;
            }
        else
            last = 0;
        }
    fclose (fms);
    return (i);
    }
#pragma page ()
void instruct (void) {
    printf ("\nUsage: MAKEDIR <fmscat.ext> <fmsdir.ext> <dir.ext>\n");
    printf ("Where:\n");
    printf ("       '<fmscat.ext>' names an RBBS FMS catalog file.\n");
    printf ("       '<fmsdir.ext>' names an RBBS FMS directory.\n");
    printf ("       '<dir.ext>'    names the directory file\n");
    printf ("Default file extension for the catalog is .CAT, and is ");
    printf (".DIR for\n    the directories.  Either may include a ");
    printf ("drive and path.\n");
    printf ("The directory file should include the drive and path ");
    printf ("for a download\n    directory.\n");
    printf ("PKZIP must be in the current directory or in a directory ");
    printf ("found in the\n    PATH environment variable.\n");
    }
#pragma page ()
void stripz (char * f) {
    int  h, i;
    long l, m;
    char *c;
    if ((h = open (f, O_BINARY | O_RDWR)) < 0)
        return;
    if ((l = filelength (h)) < 1L) {
        close (h);
        return;
        }
    m = l & 0xffffff00;
    i = (int) (l - m);
    if (i == 0) {
        i = 256;
        m = l - 256L;
        }
    if (lseek (h, (long) -i, SEEK_END) < 0L){
        close (h);
        return;
        }
    if (read (h, buf, i) != i) {
        close (h);
        return;
        }
    if ((c = strchr (buf, '\x1a')) != NULL) {
        m = m + (long) (c - buf);
        chsize (h, m);
        }
    close (h);
    }
